namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "infestation")]
public class InfestationEffect : Script, IScriptOnEndTurn, IScriptPreventSelfSwitch, IScriptPreventSelfRunAway,
    IAIInfoScriptExpectedEndOfTurnDamage
{
    private readonly IPokemon _owner;
    private int _turns;

    public InfestationEffect(IPokemon owner, int turns)
    {
        _owner = owner;
        _turns = turns;
    }

    /// <inheritdoc />
    public void PreventSelfSwitch(ISwitchChoice choice, ref bool prevent) => prevent = true;

    /// <inheritdoc />
    public void PreventSelfRunAway(IFleeChoice choice, ref bool prevent) => prevent = true;

    /// <inheritdoc />
    public void OnEndTurn(IScriptSource owner, IBattle battle)
    {
        var damage = _owner.BoostedStats.Hp / 8;
        _owner.Damage(damage, DamageSource.Misc);

        _turns--;
        if (_turns <= 0)
        {
            RemoveSelf();
        }
    }

    /// <inheritdoc />
    public void ExpectedEndOfTurnDamage(IPokemon pokemon, ref int damage)
    {
        damage += (int)(_owner.MaxHealth / 8f);
    }
}